/// <reference types="node" />
import { EventEmitter } from "events";
import { Client, ClientOptions, Message } from "discord.js";
import { BotOptions, Command, CommandData } from "../types";
interface MessageData {
    [key: string]: string;
}
export declare class Bot extends EventEmitter {
    commands: Command[];
    messages: MessageData;
    client?: Client;
    prefix: string;
    prefixShownOnMention: boolean;
    clientOptions: ClientOptions;
    private token;
    constructor(options?: BotOptions);
    setToken(token: string): Bot;
    setPrefix(prefix: string): Bot;
    showPrefixOnMention(newStatus: boolean): Bot;
    setClientOptions(options: ClientOptions): Bot;
    updateMessages(messages: MessageData): Bot;
    connect(): Promise<unknown>;
    addCommand(commandName: string, commandData: CommandData): Bot;
    handleMessage(message: Message): Promise<Message>;
}
export {};
