"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var discord_js_1 = require("discord.js");
;
var Bot = /** @class */ (function (_super) {
    __extends(Bot, _super);
    function Bot(options) {
        if (options === void 0) { options = {
            prefix: "!",
            token: "",
            clientOptions: {},
            showPrefixOnMention: true
        }; }
        var _this = _super.call(this) || this;
        _this.commands = [];
        _this.prefix = options.prefix || "!";
        _this.token = options.token || "";
        _this.prefixShownOnMention = options.showPrefixOnMention || true;
        _this.clientOptions = options.clientOptions || {};
        _this.messages = {
            memberMissingPermissions: "You don't have the right permissions to run this command!",
            botMissingPermissions: "I don't have the right permissions to run this command!",
            guildOnly: "This command can only be run on a server!",
            showPrefix: "the prefix of this server is {{prefix}}!"
        };
        return _this;
    }
    Bot.prototype.setToken = function (token) {
        this.token = token;
        return this;
    };
    Bot.prototype.setPrefix = function (prefix) {
        this.prefix = prefix;
        return this;
    };
    Bot.prototype.showPrefixOnMention = function (newStatus) {
        this.prefixShownOnMention = newStatus;
        return this;
    };
    Bot.prototype.setClientOptions = function (options) {
        this.clientOptions = options;
        return this;
    };
    Bot.prototype.updateMessages = function (messages) {
        for (var i in messages) {
            this.messages[i] = messages[i];
        }
        return this;
    };
    Bot.prototype.connect = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.client = new discord_js_1.Client(_this.clientOptions || {});
            _this.client.on('message', function (message) { return _this.handleMessage.call(_this, message); });
            _this.client.on('ready', resolve);
            _this.client.login(_this.token);
        });
    };
    Bot.prototype.addCommand = function (commandName, commandData) {
        this.commands.push({
            name: commandName,
            data: commandData || {}
        });
        return this;
    };
    Bot.prototype.handleMessage = function (message) {
        if (message.content.match(new RegExp("^<@!?" + this.client.user.id + ">( |)$"))) {
            message.reply(this.messages.showPrefix.replace("{{prefix}}", this.prefix));
        }
        var args = message.content.slice(this.prefix.length).trim().split(/ +/g);
        var command = args.shift().toLowerCase();
        var cmd = this.commands.find(function (c) { return c.name === command || ((c.data.aliases || []).includes(command)); });
        if (cmd) {
            if (message.guild) {
                if ((cmd.data.ownerOnly && (message.guild.ownerID !== message.author.id)) ||
                    (cmd.data.memberPermissions && !message.member.hasPermission(cmd.data.memberPermissions))) {
                    return message.channel.send(this.messages.memberMissingPermissions);
                }
                if (cmd.data.botPermissions && !message.channel.permissionsFor(message.guild.me).has(cmd.data.botPermissions)) {
                    return message.channel.send(this.messages.botMissingPermissions);
                }
            }
            else if (cmd.data.guildOnly) {
                return message.channel.send(this.messages.guildOnly);
            }
            if (cmd.data.reply) {
                message.reply(cmd.data.reply);
            }
            else if (cmd.data.run) {
                cmd.data.run(message, args);
            }
        }
    };
    return Bot;
}(events_1.EventEmitter));
exports.Bot = Bot;
;
